JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | List of all members
ZipFile Class Reference
juce_core » zip

Decodes a ZIP file from a stream. More...

`#include <juce_ZipFile.h>`

## Classes
class | Builder
| Used to create a new zip file. More...
struct | ZipEntry
| Contains information about one of the entries in a ZipFile. More...

## Public Types
enum class | OverwriteFiles { no , yes }
enum class | FollowSymlinks { no , yes }

## Public Member Functions
| ZipFile (const File &file)
| Creates a ZipFile to read a specific file.
| ZipFile (InputStream *inputStream, bool deleteStreamWhenDestroyed)
| Creates a ZipFile for a given stream.
| ZipFile (InputStream &inputStream)
| Creates a ZipFile for a given stream.
| ZipFile (InputSource *inputSource)
| Creates a ZipFile for an input source.
| ~ZipFile ()
| Destructor.
int | getNumEntries () const noexcept
| Returns the number of items in the zip file.
const ZipEntry * | getEntry (int index) const noexcept
| Returns a structure that describes one of the entries in the zip file.
int | getIndexOfFileName (const String &fileName, bool ignoreCase=false) const noexcept
| Returns the index of the first entry with a given filename.
const ZipEntry * | getEntry (const String &fileName, bool ignoreCase=false) const noexcept
| Returns a structure that describes one of the entries in the zip file.
void | sortEntriesByFilename ()
| Sorts the list of entries, based on the filename.
InputStream * | createStreamForEntry (int index)
| Creates a stream that can read from one of the zip file's entries.
InputStream * | createStreamForEntry (const ZipEntry &entry)
| Creates a stream that can read from one of the zip file's entries.
Result | uncompressTo (const File &targetDirectory, bool shouldOverwriteFiles=true)
| Uncompresses all of the files in the zip file.
Result | uncompressEntry (int index, const File &targetDirectory, bool shouldOverwriteFiles=true)
| Uncompresses one of the entries from the zip file.
Result | uncompressEntry (int index, const File &targetDirectory, OverwriteFiles overwriteFiles, FollowSymlinks followSymlinks)
| Uncompresses one of the entries from the zip file.

## Detailed Description

Decodes a ZIP file from a stream.

This can enumerate the items in a ZIP file and can create suitable stream objects to read each one.

## Member Enumeration Documentation

## ◆ OverwriteFiles

enum class ZipFile::OverwriteFiles
| strong

Enumerator
no |
yes |

## ◆ FollowSymlinks

enum class ZipFile::FollowSymlinks
| strong

Enumerator
no |
yes |

## Constructor & Destructor Documentation

## ◆ ZipFile() [1/4]

ZipFile::ZipFile | ( | const File & | file | ) |
| explicit

Creates a ZipFile to read a specific file.

## ◆ ZipFile() [2/4]

ZipFile::ZipFile | ( | InputStream * | inputStream,
|  | bool | deleteStreamWhenDestroyed )

Creates a ZipFile for a given stream.

Parameters

  inputStream | the stream to read from
  deleteStreamWhenDestroyed | if set to true, the object passed-in will be deleted when this ZipFile object is deleted

## ◆ ZipFile() [3/4]

ZipFile::ZipFile | ( | InputStream & | inputStream | ) |
| explicit

Creates a ZipFile for a given stream.

The stream will not be owned or deleted by this class - if you want the ZipFile to manage the stream's lifetime, use the other constructor.

## ◆ ZipFile() [4/4]

ZipFile::ZipFile | ( | InputSource * | inputSource | ) |
| explicit

Creates a ZipFile for an input source.

The inputSource object will be owned by the zip file, which will delete it later when not needed.

## ◆ ~ZipFile()

ZipFile::~ZipFile | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ getNumEntries()

int ZipFile::getNumEntries | ( |  | ) | const
| noexcept

Returns the number of items in the zip file.

## ◆ getEntry() [1/2]

const ZipEntry * ZipFile::getEntry | ( | int | index | ) | const
| noexcept

Returns a structure that describes one of the entries in the zip file.

This may return a nullptr if the index is out of range.

See also
  ZipFile::ZipEntry

## ◆ getIndexOfFileName()

int ZipFile::getIndexOfFileName | ( | const String & | fileName,
|  | bool | ignoreCase = false ) const
| noexcept

Returns the index of the first entry with a given filename.

This uses a case-sensitive comparison to look for a filename in the list of entries. It might return -1 if no match is found.

See also
  ZipFile::ZipEntry

## ◆ getEntry() [2/2]

const ZipEntry * ZipFile::getEntry | ( | const String & | fileName,
|  | bool | ignoreCase = false ) const
| noexcept

Returns a structure that describes one of the entries in the zip file.

This uses a case-sensitive comparison to look for a filename in the list of entries. It might return 0 if no match is found.

See also
  ZipFile::ZipEntry

## ◆ sortEntriesByFilename()

void ZipFile::sortEntriesByFilename | ( |  | ) |

Sorts the list of entries, based on the filename.

## ◆ createStreamForEntry() [1/2]

InputStream * ZipFile::createStreamForEntry | ( | int | index | ) |

Creates a stream that can read from one of the zip file's entries.

The stream that is returned must be deleted by the caller (and a nullptr might be returned if a stream can't be opened for some reason).

The stream must not be used after the ZipFile object that created has been deleted.

Note that if the ZipFile was created with a user-supplied InputStream object, then all the streams which are created by this method will by trying to share the same source stream, so cannot be safely used on multiple threads! (But if you create the ZipFile from a File or InputSource, then it is safe to do this).

## ◆ createStreamForEntry() [2/2]

InputStream * ZipFile::createStreamForEntry | ( | const ZipEntry & | entry | ) |

Creates a stream that can read from one of the zip file's entries.

The stream that is returned must be deleted by the caller (and a nullptr might be returned if a stream can't be opened for some reason).

The stream must not be used after the ZipFile object that created has been deleted.

Note that if the ZipFile was created with a user-supplied InputStream object, then all the streams which are created by this method will by trying to share the same source stream, so cannot be safely used on multiple threads! (But if you create the ZipFile from a File or InputSource, then it is safe to do this).

## ◆ uncompressTo()

Result ZipFile::uncompressTo | ( | const File & | targetDirectory,
|  | bool | shouldOverwriteFiles = true )

Uncompresses all of the files in the zip file.

This will expand all the entries into a target directory. The relative paths of the entries are used.

Parameters

  targetDirectory | the root folder to uncompress to
  shouldOverwriteFiles | whether to overwrite existing files with similarly-named ones

Returns
  success if the file is successfully unzipped

## ◆ uncompressEntry() [1/2]

Result ZipFile::uncompressEntry | ( | int | index,
|  | const File & | targetDirectory,
|  | bool | shouldOverwriteFiles = true )

Uncompresses one of the entries from the zip file.

This will expand the entry and write it in a target directory. The entry's path is used to determine which subfolder of the target should contain the new file.

Parameters

  index | the index of the entry to uncompress - this must be a valid index between 0 and (getNumEntries() - 1).
  targetDirectory | the root folder to uncompress into
  shouldOverwriteFiles | whether to overwrite existing files with similarly-named ones

Returns
  success if all the files are successfully unzipped

## ◆ uncompressEntry() [2/2]

Result ZipFile::uncompressEntry | ( | int | index,
|  | const File & | targetDirectory,
|  | OverwriteFiles | overwriteFiles,
|  | FollowSymlinks | followSymlinks )

Uncompresses one of the entries from the zip file.

This will expand the entry and write it in a target directory. The entry's path is used to determine which subfolder of the target should contain the new file.

Parameters

  index | the index of the entry to uncompress - this must be a valid index between 0 and (getNumEntries() - 1).
  targetDirectory | the root folder to uncompress into
  overwriteFiles | whether to overwrite existing files with similarly-named ones
  followSymlinks | whether to follow symlinks inside the target directory

Returns
  success if all the files are successfully unzipped

The documentation for this class was generated from the following file:

- juce_ZipFile.h